package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.ShopOrderService;
import com.gxwebsoft.shop.entity.ShopOrder;
import com.gxwebsoft.shop.param.ShopOrderParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 订单控制器
 *
 * @author 科技小王子
 * @since 2024-09-10 21:05:07
 */
@Api(tags = "订单管理")
@RestController
@RequestMapping("/api/shop/shop-order")
public class ShopOrderController extends BaseController {
    @Resource
    private ShopOrderService shopOrderService;

    @ApiOperation("分页查询订单")
    @GetMapping("/page")
    public ApiResult<PageResult<ShopOrder>> page(ShopOrderParam param) {
        // 使用关联查询
        return success(shopOrderService.pageRel(param));
    }

    @ApiOperation("查询全部订单")
    @GetMapping()
    public ApiResult<List<ShopOrder>> list(ShopOrderParam param) {
        PageParam<ShopOrder, ShopOrderParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(shopOrderService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(shopOrderService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:shopOrder:list')")
    @OperationLog
    @ApiOperation("根据id查询订单")
    @GetMapping("/{id}")
    public ApiResult<ShopOrder> get(@PathVariable("id") Integer id) {
        return success(shopOrderService.getById(id));
        // 使用关联查询
        //return success(shopOrderService.getByIdRel(id));
    }

    @ApiOperation("添加订单")
    @PostMapping()
    public ApiResult<?> save(@RequestBody ShopOrder shopOrder) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          shopOrder.setUserId(loginUser.getUserId());
        }
        if (shopOrderService.save(shopOrder)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改订单")
    @PutMapping()
    public ApiResult<?> update(@RequestBody ShopOrder shopOrder) {
        if (shopOrderService.updateById(shopOrder)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除订单")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (shopOrderService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加订单")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<ShopOrder> list) {
        if (shopOrderService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改订单")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<ShopOrder> batchParam) {
        if (batchParam.update(shopOrderService, "order_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除订单")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (shopOrderService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
